//+------------------------------------------------------------------+
//|                                                        BBF.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jan Klimo"
 
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 MidnightBlue
#property indicator_color2 Sienna
#property indicator_color3 Sienna
#property indicator_color4 SeaGreen
#property indicator_color5 SeaGreen
#property indicator_color6 Teal
#property indicator_color7 Teal

//---- indicator parameters
extern int    BandsShift=0;
extern int MA_Perioda = 20;
extern double Factor1 = 1.6180;
extern double Factor2 = 2.6180;
extern double Factor3 = 4.2360; //TODO: min, max odraz?


//---- buffers
double MovingBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];

double HighLow[100000];
double Deviation[100000];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_DASH);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,2);



//---- indicators
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer1);
   SetIndexBuffer(2,LowerBuffer1);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,LowerBuffer2);
   SetIndexBuffer(5,UpperBuffer3);
   SetIndexBuffer(6,LowerBuffer3);
   

//----
   SetIndexDrawBegin(0,MA_Perioda+BandsShift);
   SetIndexDrawBegin(1,MA_Perioda+BandsShift);
   SetIndexDrawBegin(2,MA_Perioda+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=MA_Perioda) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=MA_Perioda;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer1[Bars-i]=EMPTY_VALUE;
         LowerBuffer1[Bars-i]=EMPTY_VALUE;
         UpperBuffer2[Bars-i]=EMPTY_VALUE;
         LowerBuffer2[Bars-i]=EMPTY_VALUE;
         UpperBuffer3[Bars-i]=EMPTY_VALUE;
         LowerBuffer3[Bars-i]=EMPTY_VALUE;
         
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;

   for(i=0; i<limit; i++)
   {
      MovingBuffer[i]=iMA(NULL,0,MA_Perioda,BandsShift,MODE_SMA,PRICE_CLOSE,i);
      //HighLow[i] = High[i] - Low[i];
   }

   for(i=limit; i>=0; i--)
   {
      HighLow[i] = High[i] - Low[i];
      Comment(HighLow[i]);
   }

   i=Bars-MA_Perioda+1;
   if(counted_bars>MA_Perioda-1) i=Bars-counted_bars-1;
   
   while(i>=0)
     {
      Deviation[i]= iMAOnArray(HighLow, Bars, 20, 0, MODE_EMA, i); 
      
      //Alert(HighLow[i]);

      UpperBuffer1[i]=MovingBuffer[i] + Factor1*Deviation[i];
      LowerBuffer1[i]=MovingBuffer[i] - Factor1*Deviation[i];
      
      UpperBuffer2[i]=MovingBuffer[i] + Factor2*Deviation[i];
      LowerBuffer2[i]=MovingBuffer[i] - Factor2*Deviation[i];
      
      UpperBuffer3[i]=MovingBuffer[i] + Factor3*Deviation[i];
      LowerBuffer3[i]=MovingBuffer[i] - Factor3*Deviation[i];
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+